              PROGRAM TDDTSV1
*
*       ணࠬ PDDTSV
*
      include 'mpif.h'
*
      INTEGER            DLEN_, JA, IB, N, M, MB, NB, RSRC,
     $                   CSRC, MXLLDA, NRHS, NBRHS, NOUT,
     $                   MXLOCR, MXLOCC, MXRHSC, LWORK
      PARAMETER          ( DLEN_ = 7, JA = 1, IB = 1,
     $                   N = 9, M = 9, NB = 3, RSRC = 0,
     $                   CSRC = 0, MXLLDA = 9, NRHS = 1,
     $                   NBRHS = 1, NOUT = 6, MXLOCR = 9, MXLOCC = 3,
     $                   MXRHSC = 1, LWORK = 79 )
*
*  ६
      INTEGER            ICTXT, INFO, MYCOL, MYROW, NPCOL, NPROW
*
*  ᨢ
      INTEGER            DESCA( DLEN_ ), DESCB( DLEN_ ), DESCD( 9 ),
     $                   DESCBP( 9 )
      DOUBLE PRECISION   B( NB ),
     $                   DL( NB ), D( NB ), DU( NB ),
     $                   WORK( LWORK ), WORK2( 9 )
*
* 譨 ணࠬ
      EXTERNAL           BLACS_EXIT, BLACS_GRIDEXIT, BLACS_GRIDINFO,
     $                   DESCINIT, MATINIT, PDDTSV, PDLAPRNT, SL_INIT
*
*   DATA
      DATA               NPROW / 1 / , NPCOL / 3 /
*
* 믮塞 
*
* 樠 ⪨ ᮢ
*
      CALL SL_INIT( ICTXT, NPROW, NPCOL )
*
      CALL BLACS_GRIDINFO( ICTXT, NPROW, NPCOL, MYROW, MYCOL )
*
* ᫨   ⪨ ᮢ, 室   ணࠬ
*
      IF( MYROW.EQ.-1 ) GO TO 10
*
* ।   ⪥ ᮢ
*
* 樠 ਯ஢   A  B
*
      DESCA(1) = 501
      DESCA(2) = ICTXT
      DESCA(3) = N
      DESCA(4) = NB
      DESCA(5) = CSRC
      DESCA(6) = 3
      DESCA(7) = 0
*
      CALL DESCINIT( DESCD, 1, N, 1, NB, RSRC, CSRC, ICTXT, 1, INFO )
*
      DESCB(1) = 502
      DESCB(2) = ICTXT
      DESCB(3) = N
      DESCB(4) = NB
      DESCB(5) = RSRC
      DESCB(6) = 3
      DESCB(7) = 0
*
      CALL DESCINIT( DESCBP, 1, N, 1, NB, RSRC, CSRC, ICTXT, 1, INFO )
*
*  室 
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NOUT, FMT = 9999 )
         WRITE( NOUT, FMT = 9998 )N, N, NB
         WRITE( NOUT, FMT = 9997 )NPROW*NPCOL, NPROW, NPCOL
         WRITE( NOUT, FMT = * ) ' 室  '
         WRITE( NOUT, FMT = * ) '  DESCA'
         WRITE( NOUT, FMT = 9985 )DESCA
         WRITE( NOUT, FMT = * ) '  DESCB'
         WRITE( NOUT, FMT = 9985 )DESCB
         WRITE( NOUT, FMT = * ) '  DESCD'
         WRITE( NOUT, FMT = 9985 )DESCD
         WRITE( NOUT, FMT = * ) '  DESCBP'
         WRITE( NOUT, FMT = 9985 )DESCBP
      END IF
 9985 FORMAT(/9I5,//)
*
*   A  B  ।  ⪥ ᮢ
*
      CALL MATINIT( N, DL, D, DU, DESCD, B, DESCBP )
*
*  室 ஢ DU, D, DL  B
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NOUT, FMT = * ) ' D'
      END IF
      CALL PDLAPRNT( 1, N, D, 1, JA, DESCD, 0, 0, 'D', NOUT, WORK2 )
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NOUT, FMT = * ) ' DL'
      END IF
      CALL PDLAPRNT( 1, N, DL, 1, JA, DESCD, 0, 0, 'DL', NOUT, WORK2 )
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NOUT, FMT = * ) 'H DU'
      END IF
      CALL PDLAPRNT( 1, N, DU, 1, JA, DESCD, 0, 0, 'DU', NOUT, WORK2 )
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NOUT, FMT = * ) '  B'
      END IF
      CALL PDLAPRNT( 1, N, B, IB, 1, DESCBP, 0, 0, 'B', NOUT, WORK2 )
*
* 맮 ணࠬ 
*
* 襭  ⥬ A * X = B
*
      CALL  PDDTSV ( N, NRHS, DL, D, DU, JA, DESCA,
     $               B, IB, DESCB, WORK, LWORK, INFO)
*
*  १ X
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NOUT, FMT = * ) '  '
         WRITE( NOUT, FMT = 9996 )INFO
         WRITE( NOUT, FMT = * ) ' X'
      END IF
*
      CALL PDLAPRNT( 1, N, B, IB, 1, DESCBP, 0, 0, 'X', NOUT, WORK2 )
*
* ᢮  ⪨ ᮢ
*
* ᢮ ⥪ BLACS'
*
      CALL BLACS_GRIDEXIT( ICTXT )
   10 CONTINUE
*
* 室  BLACS
*
      CALL BLACS_EXIT( 0 )
*
 9999 FORMAT( / '  ணࠬ PDDTSV' )
 9998 FORMAT( / '襭 Ax=b,  A - 夨쭠  ',
     $ I3, '  ', I3, /'                   ࠧ஬  ', I3 )
 9997 FORMAT( 'ய  ', I3, ' ,  ⪠ ᮢ - ',
     $       I2, '  ', I2 /)
 9996 FORMAT( / '祭 INFO  = ', I6 /)
*
      STOP
      END
*
      SUBROUTINE MATINIT( N, DL, D, DU, DESCD, B, DESCBP )
*
* MATINIT   ।  A  B
*          ⪥ ᮢ 1 x 3
*
* ࠬ
      INTEGER            DESCD( * ), DESCBP( * )
      DOUBLE PRECISION   DL( * ), D( * ), DU( * ), B( * )
*
      INTEGER            N
*
*  ६
      DOUBLE PRECISION   T, MO, Z
*
* 譨 ணࠬ
      EXTERNAL           PDELSET
*
* 믮塞 
*
      T = 2.0D0
      MO = -1.0D0
      Z = 0.0D0
*
      DO 10 J = 1, N-1
       CALL PDELSET( D, 1, J, DESCD, T )
   10 CONTINUE
*
      DO 30 J = 2, N
      CALL PDELSET( DL, 1, J, DESCD, MO )
   30 CONTINUE
*
      DO 20 J = 1, N-1
      CALL PDELSET( DU, 1, J, DESCD, MO )
   20 CONTINUE
*
      CALL PDELSET( D, 1, N, DESCD, 1.D0 )
*
      DO 50 J = 1, N-1
        CALL PDELSET( B, 1, J, DESCBP, Z )
   50 CONTINUE
*
      CALL PDELSET( B, 1, N, DESCBP, 1.0D0 )
*
      RETURN
      END
